#include <stdint.h>						// Avoided bug for compile error stm32f4xx_tim.h->stm32f4xx.h
#include "stm32f4xx_it.h"
#include "stm32f4xx_tim.h"
//#include "stm32f4_discovery.h"
#include <stdio.h>
#include <stdarg.h>

void NMI_Handler(void){
	printf("*NMI_Handler*\n");
}

#ifndef DEL
void HardFault_Handler(unsigned long dummy, ...){
	va_list			ap;
	unsigned long	*p;
	int				i;

	printf("*HardFault*\n");
	printf("Stack=0x%08x\n", (unsigned int)dummy);
	va_start(ap, dummy);
	for(i = 0; i < 10; i++){
		p = va_arg(ap, unsigned long *);
		printf("Stack=0x%08x\n", (unsigned int)p);
	}
	va_end(ap);
	for(;;);
}
#else
void HardFault_Handler(void){
//	STM_EVAL_LEDOn(LED5);	// Red
	printf("*HardFault*\n");
	for(;;);
}
#endif

void MemManage_Handler(void){
//	STM_EVAL_LEDOn(LED5);	// Red
	printf("*MemManage*\n");
	for(;;);
}

void BusFault_Handler(void){
//	STM_EVAL_LEDOn(LED5);	// Red
	printf("*BusFault*\n");
	for(;;);
}

void UsageFault_Handler(void){
//	STM_EVAL_LEDOn(LED5);	// Red
	printf("*UsageFault*\n");
	for(;;);
}

void SVC_Handler(void){
	printf("*SVC_Handler*\n");
}

void DebugMon_Handler(void){
	printf("*DebugMon_Handler*\n");
}

void PendSV_Handler(void){
	printf("*PendSV_Handler*\n");
}

void SysTick_Handler(void){
}

void USART2_IRQHandler(void){
}

void ADC_IRQHandler(void) {
}

void TIM2_IRQHandler(void){
}

void TIM3_IRQHandler(void) {
}

#include "rtc.h"
void TIM4_IRQHandler(void){						// TIM4: rtc.c
	TIM_ClearITPendingBit(TIM4, TIM_IT_Update|TIM_IT_CC1|TIM_IT_CC2|TIM_IT_CC3|TIM_IT_CC1|TIM_IT_COM|TIM_IT_Trigger|TIM_IT_Break);
	rtc_time++;									// 1sec interval
	return;
}

void OTG_FS_IRQHandler(void){
}

